; To build: snarfblasm.exe buffet.asm -INVALID:OFF


; Controls which version of the game (PRG0 or PRG1) to tailor the patch to.
dVersionIsPrg1 := $00


current_level        := $10  ; #$00 = Overworld/Caves, #$01-09 = Dungeons.
current_task         := $11
current_mode         := $12
current_state        := $13
current_ppu_sequence := $14
frame_counter        := $15
current_save_slot    := $16  ; 0-2 (3 and 4 for selection screen options).
random_lfsr          := $18
delay_game_timer     := $3C
sword_disable_timer  := $4C  ; Runs off of stun_timer_tick.
ten_count            := $50
drop_forced_bomb     := $51
entrance_type_unknown := $5A
switch_base_nametable := $5C
enemy_target_pos_x   := $61
enemy_target_pos_y   := $62

entrance_tile        := $65  ; If #$24, exiting underground areas will behave as a cave entrance (climbing stairs).
                             ; Otherwise, Link just appears.
pause_status         := $E0  ; 0 = unpaused. Bit 1 = healing-paused. Bit 0 = select-paused.
start_menu_status    := $E1
is_scrolling         := $E3
current_screen       := $EB
has_init_sram        := $F4
joypad1_press        := $F8  ; ABSeStUDLR. Buttons pressed this frame.
ppu_mask_value       := $FE
ppu_control_value    := $FF

mutable_ppu_sequence_size  := $0301
mutable_ppu_sequence       := $0302 

current_sprite_number := $0341  ; The number of the next sprite tile, used to find the offset of the tile in the
                                     ; sprite region.
num_enemies_loaded   := $034E
num_enemies_killed   := $034F


halt_objects         := $051E  ; When set, causes all object processing to halt.
room_light_mode      := $051F
recorder_destination_counter := $0523
spawn_counter        := $0524  ; Ranges 0-8.
edge_spawn_position  := $0525  ; YX block position at which to edge-spawn an enemy.
cave_exit_screen     := $0526
kill_counter         := $052A  ; Used as an index into the enemy's group's item drop table.
fairy_counter        := $0627

is_second_quest      := $062D  ; - $62F (#$3). Indexed by save slot.

current_sword                := $0657  ; 0 = none, 1 = wooden, 2 = white, 3 = magical
num_bombs                    := $0658
current_arrow                := $0659  ; 0 = none, 1 = wooden, 2 = silver
has_bow                      := $065A
current_candle               := $065B  ; 0 = none, 1 = blue, 2 = red
has_recorder                 := $065C
has_bait                     := $065D
current_potion               := $065E  ; 0 = none, 1 = blue, 2 = red (higher values are valid, better potions, but
                                       ; are miscolored. Palette is (value-1) % 4)
has_magical_rod              := $065F
has_raft                     := $0660
has_book_of_magic            := $0661
current_ring                 := $0662  ; 0 = none, 1 = blue, 2 = red (higher values are valid, better rings, but
                                       ; are miscolored. Palette is (value-1) % 4)
has_stepladder               := $0663
has_magical_key              := $0664
has_power_bracelet           := $0665
has_letter                   := $0666
has_compass                  := $0667  ; 1 bit per level
has_map                      := $0668  ; 1 bit per level
has_compass_level_9          := $0669
has_map_level_9              := $066A

has_clock                    := $066C
num_rupees                   := $066D
num_keys                     := $066E
health                       := $066F  ; High nybble = total heart containers - 1, Low nybble = filled heart containers.
health_fraction              := $0670  ; 0 = empty, 1-7F = appears half full, 80-ff = appears full.
has_triforce                 := $0671  ; 1 bit per level
has_triforce_of_power        := $0672

has_boomerang                := $0674
has_magical_boomerang        := $0675
has_magical_shield           := $0676

max_bombs                    := $067C


dungeon_screen_enemy_status  := $0560  ; - $5DF (#$80). Low nybble = enemies killed.
recent_screens               := $0621  ; - $626 (#$6). Most recently visited screens. If not on this list and all enemies are killed, enemies 
overworld_screen_status      := $067F  ; - $6FE (#$80). Flags:
                                       ; 7:   Bomb/fire secret found
                                       ; 5:   Bracelet-shortcut staircase found
                                       ; 4:   Item collected
                                       ; 2-0: Enemies killed. If all killed, set to 111. Does not track Zora.
dungeon_screen_status_map1   := $06FF  ; - $77E (#$80). Flags for levels 1-6:
                                       ; 7:   All enemies killed?
                                       ; 6:   All enemies killed?
                                       ; 5:   Visited (mapped)
                                       ; 4:   Item collected
                                       ; 3-0: UDLR door unlocked
dungeon_screen_status_map2   := $077F  ; - $7FE (#$80). Flags for levels 7-9:
                                       ; 7:   All enemies killed?
                                       ; 6:   All enemies killed?
                                       ; 5:   Visited (mapped)
                                       ; 4:   Item collected
                                       ; 3-0: UDLR door unlocked


link_pos_x := $70
link_pos_y := $84
link_face_direction := $98
link_subgrid_offset  := $0394
link_subpos          := $03A8
link_speed := $03BC
link_collision_tile := $049E

object_pos_x := $70
object_pos_y := $84
object_status := $AC
dynamic_id := $34F


current_area_table_0   := $687E
current_area_table_1   := $68FE
current_area_table_2   := $697E
current_area_table_3   := $69FE
current_area_table_4   := $6A7E
current_area_table_5   := $6AFE
current_level_metadata := $6B7E


; New variables.
show_target := $4F
nmi_counter := $F0
scroll_type := $F1
secs   := $110
frames := $111
show_lag := $112
force_update := $113
is_menu_active := $114
current_menu_state := $115
current_menu_entry := $116
change_flags := $117
current_byte_cache := $118
current_address_low := $119
current_address_high := $11A
show_ganon := $11B
scroll_fast := $11C
dummy_var := $11D
force_entry_screen := $11E
menu_entry_invalid := $11F
force_enemies := $120
force_enemy_id := $121
force_enemy_quantity := $122
skip_saving_kills := $123



BuildHudPpuSequence := $6CC0
GetOppositeDirection := $7013
AbsoluteValue := $701F
UseJumpTable := $E5E2
dBitTable := $E6BE
SwitchBank := $FFAC


.IF !dVersionIsPrg1
InitMode09 := $910A
InitMode0B := $9080
InitMode0C := $9097
.ELSE
InitMode09 := $9114
InitMode0B := $908A
InitMode0C := $90A1
.ENDIF


PPU_CONTROL   := $2000
PPU_MASK      := $2001
PPU_STATUS    := $2002
PPU_ADDRESS   := $2006
PPU_DATA      := $2007
SOUND_CONTROL := $4015  ; Write-only



.PATCH 01:A13E

; Optimizes this function to only check one slot for the moving block instead of all of them. This saves a constant
; amount of time each frame of around 300 cycles.
; HandleMovingBlockCollision:
  LDA dynamic_id + $0B
  CMP #$68
  BEQ +
  CMP #$62
  BEQ +
  CMP #$65
  BEQ +
  CMP #$66
  BNE HandleMovingBlockCollision_Done
 +

  LDA <object_status + $0B,X
  CMP #$01
  BNE HandleMovingBlockCollision_Done

  LDA <link_pos_x
  SEC
  SBC <object_pos_x + $0B,X
  JSR AbsoluteValue
  CMP #$10
  BCS HandleMovingBlockCollision_Done

  LDA <link_pos_y
  CLC
  ADC #$03
  SEC
  SBC <object_pos_y + $0B,X
  JSR AbsoluteValue
  CMP #$10
  BCS HandleMovingBlockCollision_Done

  LDA #$00
  STA <$0F

 HandleMovingBlockCollision_Done:
  RTS



.PATCH $7761
.BASE  $7EE1

ShowTarget:
  ; If show_target is enabled, draw an indicator at the position enemies target.
  LDA show_target
  BNE +
  JMP $E78A

 +
  LDA enemy_target_pos_y
  STA $025C  ; Y.

  LDA #$45
  STA $025D  ; Tile ID.

  LDA #$02
  STA $025E  ; Flags.

  LDA enemy_target_pos_x
  STA $025F  ; X.

  JMP $E78A

  .IF $ > $8000
  .ERROR ShowTarget too long.
  .ENDIF



.PATCH 02:8A8F

  .INCBIN "practice_hud_graphics.dat"

  .IF $ > $8D7F
  .ERROR "practice_hud_graphics.dat" too large (max $270 bytes).
  .ENDIF



.PATCH 02:B000

 --
  JMP HandlePracticeMenu  

 -
  ; If unpausing, this needs to take 15 frames.
  CPX #$01
  BNE --
  DEX
  STA is_menu_active
  NOP
  JMP HandleModeGameplayTask1_DoUnpause  

 --
  RTS

HandleModeGameplayTask1:
  LDA <delay_game_timer
  BNE --
  LDA halt_objects
  BEQ +
  JMP HandleFrame_DoHaltedObjects

 +
  ; 12
  LDA start_menu_status
  BNE HandleModeGameplay_CheckSubscreen

  LDY #$F8

  LDX is_menu_active
  BNE -

  LDA pause_status
  LSR
  BNE HandleModeGameplay_HandlePause
;15
  LDA joypad1_press
  AND #$20
  BCC HandleModeGameplay_CheckPausing

  ; Check unpausing.
  BEQ +
 HandleModeGameplayTask1_DoUnpause:
  STY $0250
  STX pause_status
  LDA #$0F
  STA SOUND_CONTROL
  BNE HandleModeGameplay_CheckSubscreen  ; 22 cycles

; orig 36 unpausing, this 43 cycles

 +
  LDA joypad1_press
  AND #$10
  BEQ HandleModeGameplay_HandlePause
  JMP HandlePracticeMenu

 HandleModeGameplay_CheckPausing:
  BNE HandleModeGameplay_InitPause

 HandleModeGameplay_CheckSubscreen:
  JMP HandleFrame_ContinueBank7

; orig 21 cycles, this 28 cycles
; Both paths are now 7 cycles longer.

 HandleModeGameplay_InitPause:
  ; Place the sprite indicating that Start opens the menu.
  LDA #$2E
  STA $0250
  LDA #$3F
  STA $0251
  LDA #$02
  STA $0252
  LDA #$7C
  STA $0253

  INC pause_status

 HandleModeGameplay_HandlePause:
  JMP HandleFrame_FinishHandlePause



; Menu entry modes.
kEditModeByte := $00
kEditModeBinary := $01
kEditModeBool := $02
kEditModeConfirm := $03
kEditModeMemory := $04
kEditModeVersion := $05


; Pointers to the various menu entry structs.
dMenuEntryPointers:
 dMenuPage1:
 dMenuSpecialLevel:
  .dw dMenuLevel
 dMenuSpecialScreen:
  .dw dMenuScreen
  .dw dMenuLinkPosX
  .dw dMenuLinkPosY
 dMenuSpecialLinkSubgridOffset:
  .dw dMenuLinkSubgridOffset
  .dw dMenuLinkSubposition
 dMenuPage2:
  .dw dMenuGlobalCounter
  .dw dMenuStreakCounter
  .dw dMenuStoredBomb
  .dw dMenuFairyCounter
  .dw dMenuRecorderCounter
  .dw dMenuSpawnCounter
 dMenuSpecialEdgeSpawn:
  .dw dMenuEdgeSpawnPosition
 dMenuPage3:
 dMenuSpecialHealth:
  .dw dMenuHealth
  .dw dMenuHealthFraction
  .dw dMenuSword
  .dw dMenuBoomerang
  .dw dMenuMagicalBoomerang
  .dw dMenuBombs
  .dw dMenuBombCapacity
  .dw dMenuBow
  .dw dMenuArrow
  .dw dMenuCandle
  .dw dMenuRecorder
  .dw dMenuBait
  .dw dMenuLetter
  .dw dMenuPotion
  .dw dMenuMagicalRod
  .dw dMenuRaft
  .dw dMenuBookOfMagic
 dMenuSpecialRing:
  .dw dMenuRing
  .dw dMenuStepladder
  .dw dMenuMagicalKey
  .dw dMenuPowerBracelet
  .dw dMenuMagicalShield
  .dw dMenuClock
  .dw dMenuRupees
  .dw dMenuKeys
  .dw dMenuMap
  .dw dMenuMapLevel9
  .dw dMenuCompass
  .dw dMenuCompassLevel9
  .dw dMenuTriforce
  .dw dMenuTriforceOfPower
 dMenuPage4:
 dMenuLastPage:
  .dw dMenuForceEnemies
 dMenuSpecialForceEnemyId:
  .dw dMenuForceEnemyId
  .dw dMenuForceEnemyQuantity
 dMenuSpecialClearScreen:
  .dw dMenuClearScreen
 dMenuSpecialReviveEnemies:
  .dw dMenuReviveEnemies
  .dw dMenuShowGanon
  .dw dMenuShowTarget
  .dw dMenuShowPerfMonitor
  .dw dMenuFastDungeonScroll
 dMenuSpecialEditMemory:
  .dw dMenuEditMemory
 dMenuSpecialVersion:
  .dw dMenuVersion
 dMenuEntryPointers_End:

dMenuPages:
  .db <((dMenuPage1 - dMenuEntryPointers) >> 1)
  .db <((dMenuPage2 - dMenuEntryPointers) >> 1)
  .db <((dMenuPage3 - dMenuEntryPointers) >> 1)
  .db <((dMenuPage4 - dMenuEntryPointers) >> 1)
 dMenuPages_Terminator:
  .db $FF


; Menu entry structs. Format is:
;   word: variable address
;   byte: mode
;   (if mode == kEditModeByte) byte: Limit (upper bound). Lower bound is assumed to be 00.
;   char[]: FF-terminated string.
dMenuLevel:
  .dw current_level
  .db kEditModeByte
  .db $09
  .db $15,$e,$1f,$e,$15
  .db $FF
dMenuScreen:
  .dw current_screen
  .db kEditModeByte
  .db $7F
  .db $1c,$c,$1b,$e,$e,$17
  .db $FF
dMenuLinkPosX:
  .dw link_pos_x
  .db kEditModeByte
  .db $FF
  .db $15,$12,$17,$14,$24,$19,$18,$1c,$12,$1d,$12,$18,$17,$24,$21
  .db $FF
dMenuLinkPosY:
  .dw link_pos_y
  .db kEditModeByte
  .db $FF
  .db $15,$12,$17,$14,$24,$19,$18,$1c,$12,$1d,$12,$18,$17,$24,$22
  .db $FF
dMenuLinkSubgridOffset:
  .dw link_subgrid_offset
  .db kEditModeByte
  .db $FF
  .db $15,$12,$17,$14,$24,$1c,$1e,$b,$10,$1b,$12,$d,$24,$19,$18,$1c,$2c
  .db $FF
dMenuLinkSubposition:
  .dw link_subpos
  .db kEditModeByte
  .db $FF
  .db $15,$12,$17,$14,$24,$1c,$1e,$b,$19,$12,$21,$e,$15,$24,$19,$18,$1c,$2c
  .db $FF
dMenuGlobalCounter:
  .dw kill_counter
  .db kEditModeByte
  .db $09
  .db $10,$15,$18,$b,$a,$15,$24,$c,$18,$1e,$17,$1d,$e,$1b
  .db $FF
dMenuStreakCounter:
  .dw ten_count
  .db kEditModeByte
  .db $0A
  .db $1c,$1d,$1b,$e,$a,$14,$24,$c,$18,$1e,$17,$1d,$e,$1b
  .db $FF
dMenuStoredBomb:
  .dw drop_forced_bomb
  .db kEditModeBool
  .db $1c,$1d,$18,$1b,$e,$d,$24,$b,$18,$16,$b
  .db $FF
dMenuFairyCounter:
  .dw fairy_counter
  .db kEditModeByte
  .db $FF
  .db $f,$a,$12,$1b,$22,$24,$c,$18,$1e,$17,$1d,$e,$1b
  .db $FF
dMenuRecorderCounter:
  .dw recorder_destination_counter
  .db kEditModeByte
  .db $FF
  .db $1b,$e,$c,$18,$1b,$d,$e,$1b,$24,$c,$18,$1e,$17,$1d,$e,$1b
  .db $FF
dMenuSpawnCounter:
  .dw spawn_counter
  .db kEditModeByte
  .db $08
  .db $1c,$19,$a,$20,$17,$24,$c,$18,$1e,$17,$1d,$e,$1b
  .db $FF
dMenuEdgeSpawnPosition:
  .dw edge_spawn_position
  .db kEditModeByte
  .db $FF
  .db $e,$d,$10,$e,$24,$1c,$19,$a,$20,$17,$24,$19,$18,$1c,$2c
  .db $FF
dMenuHealth:
  .dw health
  .db kEditModeByte
  .db $FF
  .db $11,$e,$a,$15,$1d,$11
  .db $FF
dMenuHealthFraction:
  .dw health_fraction
  .db kEditModeByte
  .db $FF
  .db $11,$e,$a,$15,$1d,$11,$24,$f,$1b,$a,$c,$1d,$12,$18,$17
  .db $FF
dMenuSword:
  .dw current_sword
  .db kEditModeByte
  .db $03
  .db $1c,$20,$18,$1b,$d
  .db $FF
dMenuBoomerang:
  .dw has_boomerang
  .db kEditModeBool
  .db $b,$18,$18,$16,$e,$1b,$a,$17,$10
  .db $FF
dMenuMagicalBoomerang:
  .dw has_magical_boomerang
  .db kEditModeBool
  .db $16,$a,$10,$12,$c,$a,$15,$24,$b,$18,$18,$16,$e,$1b,$a,$17,$10
  .db $FF
dMenuBombs:
  .dw num_bombs
  .db kEditModeByte
  .db $FF
  .db $b,$18,$16,$b,$1c
  .db $FF
dMenuBombCapacity:
  .dw max_bombs
  .db kEditModeByte
  .db $FF
  .db $b,$18,$16,$b,$24,$c,$a,$19,$a,$c,$12,$1d,$22
  .db $FF
dMenuBow:
  .dw has_bow
  .db kEditModeBool
  .db $b,$18,$20
  .db $FF
dMenuArrow:
  .dw current_arrow
  .db kEditModeByte
  .db $02
  .db $a,$1b,$1b,$18,$20
  .db $FF
dMenuCandle:
  .dw current_candle
  .db kEditModeByte
  .db $02
  .db $c,$a,$17,$d,$15,$e
  .db $FF
dMenuRecorder:
  .dw has_recorder
  .db kEditModeBool
  .db $1b,$e,$c,$18,$1b,$d,$e,$1b
  .db $FF
dMenuBait:
  .dw has_bait
  .db kEditModeBool
  .db $b,$a,$12,$1d
  .db $FF
dMenuLetter:
  .dw has_letter
  .db kEditModeByte
  .db $02
  .db $15,$e,$1d,$1d,$e,$1b
  .db $FF
dMenuPotion:
  .dw current_potion
  .db kEditModeByte
  .db $02
  .db $19,$18,$1d,$12,$18,$17
  .db $FF
dMenuMagicalRod:
  .dw has_magical_rod
  .db kEditModeBool
  .db $16,$a,$10,$12,$c,$a,$15,$24,$1b,$18,$d
  .db $FF
dMenuRaft:
  .dw has_raft
  .db kEditModeBool
  .db $1b,$a,$f,$1d
  .db $FF
dMenuBookOfMagic:
  .dw has_book_of_magic
  .db kEditModeBool
  .db $b,$18,$18,$14,$24,$18,$f,$24,$16,$a,$10,$12,$c
  .db $FF
dMenuRing:
  .dw current_ring
  .db kEditModeByte
  .db $02
  .db $1b,$12,$17,$10
  .db $FF
dMenuStepladder:
  .dw has_stepladder
  .db kEditModeBool
  .db $1c,$1d,$e,$19,$15,$a,$d,$d,$e,$1b
  .db $FF
dMenuMagicalKey:
  .dw has_magical_key
  .db kEditModeBool
  .db $16,$a,$10,$12,$c,$a,$15,$24,$14,$e,$22
  .db $FF
dMenuPowerBracelet:
  .dw has_power_bracelet
  .db kEditModeBool
  .db $19,$18,$20,$e,$1b,$24,$b,$1b,$a,$c,$e,$15,$e,$1d
  .db $FF
dMenuMagicalShield:
  .dw has_magical_shield
  .db kEditModeBool
  .db $16,$a,$10,$12,$c,$a,$15,$24,$1c,$11,$12,$e,$15,$d
  .db $FF
dMenuClock:
  .dw has_clock
  .db kEditModeBool
  .db $c,$15,$18,$c,$14
  .db $FF
dMenuRupees:
  .dw num_rupees
  .db kEditModeByte
  .db $FF
  .db $1b,$1e,$19,$e,$e,$1c
  .db $FF
dMenuKeys:
  .dw num_keys
  .db kEditModeByte
  .db $FF
  .db $14,$e,$22,$1c
  .db $FF
dMenuMap:
  .dw has_map
  .db kEditModeBinary
  .db $16,$a,$19,$1c
  .db $FF
dMenuMapLevel9:
  .dw has_map_level_9
  .db kEditModeBool
  .db $16,$a,$19,$24,$15,$e,$1f,$e,$15,$24,$9
  .db $FF
dMenuCompass:
  .dw has_compass
  .db kEditModeBinary
  .db $c,$18,$16,$19,$a,$1c,$1c,$e,$1c
  .db $FF
dMenuCompassLevel9:
  .dw has_compass_level_9
  .db kEditModeBool
  .db $c,$18,$16,$19,$a,$1c,$1c,$24,$15,$e,$1f,$e,$15,$24,$9
  .db $FF
dMenuTriforce:
  .dw has_triforce
  .db kEditModeBinary
  .db $1d,$1b,$12,$f,$18,$1b,$c,$e,$24,$1e,$17,$12,$1d,$1c
  .db $FF
dMenuTriforceOfPower:
  .dw has_triforce_of_power
  .db kEditModeBool
  .db $1d,$1b,$12,$f,$18,$1b,$c,$e,$24,$18,$f,$24,$19,$18,$20,$e,$1b
  .db $FF
dMenuForceEnemies:
  .dw force_enemies
  .db kEditModeBool
  .db $f,$18,$1b,$c,$e,$24,$e,$17,$e,$16,$12,$e,$1c
  .db $FF
dMenuForceEnemyId:
  .dw force_enemy_id
  .db kEditModeByte
  .db $7F
  .db $f,$18,$1b,$c,$e,$24,$e,$17,$e,$16,$22,$24,$12,$d
  .db $FF
dMenuForceEnemyQuantity:
  .dw force_enemy_quantity
  .db kEditModeByte
  .db $08
  .db $f,$18,$1b,$c,$e,$24,$e,$17,$e,$16,$22,$24,$a,$16,$18,$1e,$17,$1d
  .db $FF
dMenuClearScreen:
  .dw dummy_var
  .db kEditModeConfirm
  .db $c,$15,$e,$a,$1b,$24,$1c,$c,$1b,$e,$e,$17
  .db $FF
dMenuReviveEnemies:
  .dw dummy_var
  .db kEditModeConfirm
  .db $1b,$e,$1f,$12,$1f,$e,$24,$e,$17,$e,$16,$12,$e,$1c
  .db $FF
dMenuShowGanon:
  .dw show_ganon
  .db kEditModeBool
  .db $1c,$11,$18,$20,$24,$10,$a,$17,$18,$17
  .db $FF
dMenuShowTarget:
  .dw show_target
  .db kEditModeBool
  .db $1c,$11,$18,$20,$24,$1d,$a,$1b,$10,$e,$1d
  .db $FF
dMenuShowPerfMonitor:
  .dw show_lag
  .db kEditModeBool
  .db $1c,$11,$18,$20,$24,$19,$e,$1b,$f,$2c,$24,$16,$18,$17,$12,$1d,$18,$1b
  .db $FF
dMenuFastDungeonScroll:
  .dw scroll_fast
  .db kEditModeBool
  .db $f,$a,$1c,$1d,$24,$d,$1e,$17,$10,$e,$18,$17,$24,$1c,$c,$1b,$15,$2c
  .db $FF
dMenuEditMemory:
  .dw $0008  ; Mostly a dummy value.
  .db kEditModeMemory
  .db $e,$d,$12,$1d,$24,$16,$e,$16,$18,$1b,$22
  .db $FF
dMenuVersion:
  .dw dummy_var
  .db kEditModeVersion
  .db $b,$1e,$f,$f,$e,$1d,$24,$1f,$e,$1b,$1c,$12,$18,$17
  .db $FF


; Strings.
dValueBoolYes:
  .db $22,$e,$1c
 dValueBoolYes_End:

dValueBoolNo:
  .db $17,$18
 dValueBoolNo_End:

dValueConfirm:
  .db $c,$18,$17,$f,$12,$1b,$16,$2e
 dValueConfirm_End:


; Valid edge spawns for restricting the variable to valid values.
dValidEdgeSpawns:
  .db $40,$50,$60,$70,$80,$90,$A0,$B0,$C0,$D0
  .db $E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF
  .db $DF,$CF,$BF,$AF,$9F,$8F,$7F,$6F,$5F
  .db $4E,$4D,$4C,$4B,$4A,$49,$48,$47,$46,$45,$44,$43,$42,$41
 dValidEdgeSpawns_End:
  .db $00


; Low nybble for animation frames for the arrow and overline.
dMenuArrowRowOffsets:
  .db $07,$09,$0B,$09


; Bit 0-7 for levels 1-8, and both bits 6 and 7 for level 9.
dValidDungeonScreens:
  ; First quest.
  .db $08|$00,$08|$C0,$08|$C0,$08|$C0,$00|$C0,$10|$C0,$10|$C0,$00|$C0,$00|$40,$20|$40,$20|$40,$20|$40,$20|$40,$02|$40,$02|$80,$00|$00
  .db $08|$C0,$08|$C0,$08|$C0,$08|$C0,$10|$C0,$10|$C0,$10|$C0,$10|$C0,$20|$40,$20|$40,$20|$40,$20|$40,$20|$40,$20|$80,$02|$80,$02|$80
  .db $08|$C0,$08|$C0,$01|$C0,$01|$C0,$10|$C0,$10|$C0,$10|$C0,$10|$C0,$20|$40,$20|$40,$04|$40,$04|$40,$20|$80,$20|$80,$02|$80,$02|$00
  .db $08|$C0,$08|$C0,$08|$C0,$01|$C0,$10|$C0,$01|$C0,$01|$C0,$10|$C0,$20|$40,$20|$40,$20|$40,$04|$80,$20|$80,$04|$80,$02|$80,$02|$80
  .db $08|$C0,$01|$C0,$01|$C0,$01|$C0,$01|$C0,$01|$C0,$10|$C0,$10|$C0,$20|$40,$04|$40,$04|$00,$04|$80,$04|$80,$04|$80,$02|$80,$02|$00
  .db $08|$C0,$08|$C0,$01|$C0,$01|$C0,$01|$C0,$10|$C0,$10|$C0,$10|$C0,$20|$40,$04|$40,$04|$40,$04|$40,$04|$80,$04|$80,$02|$80,$02|$80
  .db $00|$00,$08|$C0,$08|$C0,$01|$C0,$10|$C0,$10|$C0,$10|$C0,$10|$00,$20|$40,$04|$40,$20|$40,$04|$40,$02|$40,$02|$40,$02|$80,$02|$00
  .db $08|$00,$08|$C0,$01|$00,$01|$C0,$01|$C0,$00|$00,$10|$C0,$10|$00,$20|$40,$20|$40,$20|$40,$04|$00,$04|$80,$02|$80,$02|$80,$00|$80
  ; Second quest.
  .db $08|$C0,$08|$C0,$08|$00,$00|$00,$20|$00,$20|$00,$20|$C0,$01|$C0,$01|$40,$00|$40,$04|$40,$00|$40,$10|$40,$10|$40,$10|$40,$00|$40
  .db $08|$C0,$08|$C0,$08|$C0,$20|$C0,$20|$C0,$02|$C0,$20|$C0,$01|$C0,$01|$40,$04|$40,$04|$80,$04|$80,$10|$80,$10|$80,$10|$80,$10|$40
  .db $02|$00,$00|$00,$08|$C0,$20|$C0,$20|$C0,$02|$C0,$20|$00,$01|$00,$00|$40,$04|$40,$04|$80,$04|$00,$10|$00,$10|$40,$10|$80,$10|$40
  .db $02|$00,$08|$C0,$08|$C0,$20|$C0,$20|$C0,$02|$C0,$20|$C0,$01|$00,$01|$40,$04|$40,$04|$80,$04|$80,$10|$80,$10|$40,$10|$80,$10|$40
  .db $08|$C0,$08|$C0,$20|$C0,$20|$C0,$20|$C0,$02|$C0,$00|$C0,$01|$C0,$01|$40,$04|$40,$04|$80,$04|$80,$10|$80,$10|$40,$10|$80,$10|$40
  .db $08|$C0,$20|$C0,$20|$C0,$20|$C0,$20|$C0,$02|$C0,$00|$C0,$01|$C0,$00|$40,$04|$40,$04|$80,$04|$80,$10|$80,$10|$40,$10|$80,$10|$40
  .db $08|$00,$08|$C0,$08|$C0,$20|$C0,$20|$C0,$02|$C0,$02|$C0,$01|$00,$01|$40,$04|$40,$00|$40,$04|$40,$10|$40,$10|$40,$10|$80,$10|$40
  .db $08|$00,$08|$00,$08|$00,$00|$C0,$20|$C0,$02|$00,$02|$00,$01|$00,$01|$80,$04|$80,$00|$80,$04|$80,$10|$80,$10|$80,$10|$80,$00|$40



HandlePracticeMenu:
  LDA ppu_mask_value
  AND #$FE
  STA ppu_mask_value

  LDA #$00
  STA menu_entry_invalid

  ; If the menu is active, run it.
  BIT is_menu_active
  BMI HandlePracticeMenu_MenuActive
  BVC HandlePracticeMenu_ActivateMenu

  ; We're unpausing. This is the delay frame needed for clearing out the HUD. Set up for returning to gameplay.
  LDX #$01
  STX is_menu_active

  JSR HandleChangeFlags

  JMP BuildHudPpuSequence


 HandlePracticeMenu_MenuActive:
  JSR GetMenuPointers

  ; Handle the input. If something changed and the HUD needs to be updated, $06 will be set.
  JSR HandleMenuInput
  LDA $06
  BNE HandlePracticeMenu_BuildPpuSequence

  ; If the memory editor is selected, update every frame.
  LDA current_menu_entry
  CMP #<((dMenuSpecialEditMemory - dMenuEntryPointers)/2)
  BNE +
  JSR LoadMemoryEditorValue
  JMP HandlePracticeMenu_BuildPpuSequence
 +

  ; Animate the arrow.
  LDA frame_counter
  LSR
  LSR
  LSR
  AND #$03
  TAY
  LDA $0251
  AND #$F0
  ORA dMenuArrowRowOffsets,Y
  STA $0251  ; Tile ID.

  JMP BuildHudPpuSequence
  

 HandlePracticeMenu_ActivateMenu:
  LDA #$80
  STA is_menu_active

 HandlePracticeMenu_BuildPpuSequence:
  JSR CheckMenuEntryValid

  JSR GetMenuPointers

  JSR DrawMenuArrow

  ; Set up the PPU sequence.
  LDA #$20
  STA mutable_ppu_sequence
  LDA #$E0
  STA mutable_ppu_sequence+1
  LDA #$20
  STA mutable_ppu_sequence+2
  LDA #$FF
  STA mutable_ppu_sequence+3+32
  LDA #$23
  STA mutable_ppu_sequence_size

  ; Clear the buffer.
  LDA #$24
  LDY #$1F
 -
  STA mutable_ppu_sequence+3,Y
  DEY
  BPL -

  ; Write the page number.
  JSR GetCurrentMenuPage
  STY mutable_ppu_sequence+3+2
  LDA #$2C
  STA mutable_ppu_sequence+3+3

  ; Copy over the text.
  LDY #$FF
 -
  INY
  LDA ($04),Y
  BMI +
  STA mutable_ppu_sequence+3+4,Y
  BPL -
 +

  ; Write the target value to the buffer.
  ; First, load the cached value if we're editing the entry, or the real value otherwise.
  LDA current_menu_state
  BNE +
  LDY #$00
  LDA ($02),Y
  JMP ++
 +
  LDA current_byte_cache
 ++
  PHA

  ; Get the mode number to figure out how to write the value.
  LDY #$02
  LDA ($00),Y
  TAX
  PLA
  DEX
  BPL HandlePracticeMenu_BuildPpuSequence_CheckModeBinary

  LDY #28
 HandlePracticeMenu_BuildPpuSequence_ModeByte:
  ; Write as a hex byte.
  ; Stash the value, since we need to pull out nybbles individually.
  TAX

  ; If there is an upper limit and it's under #$10, then only draw 1 digit.
  LDA $0F
  BEQ +
  CMP #$10
  BCC ++
 +

  ; Upper nybble.
  TXA
  LSR
  LSR
  LSR
  LSR
  STA mutable_ppu_sequence+3,Y

 ++
  ; Lower nybble.
  TXA
  AND #$0F
  STA mutable_ppu_sequence+4,Y

  ; If we're editing a ring, we also need to update Link's palette.
  LDA current_menu_entry
  CMP #<((dMenuSpecialRing - dMenuEntryPointers)/2)
  BNE +

  ; Append a PPU sequence that writes Link's new color to the appropriate sprite palette address.
  LDA #$3F
  STA mutable_ppu_sequence+3+32+0
  LDA #$11
  STA mutable_ppu_sequence+3+32+1
  LDA #$01
  STA mutable_ppu_sequence+3+32+2

  ; Set the ring color and note that Link should use this color in general.
  LDX current_save_slot
  LDY current_ring
  LDA $7325,Y  ; Link colors.
  STA mutable_ppu_sequence+3+32+3
  LDY $EA0E,X
  STA $6804,Y

  LDA #$FF
  STA mutable_ppu_sequence+3+32+4

  LDA #3+32+4
  STA mutable_ppu_sequence_size
 +

  RTS


 HandlePracticeMenu_BuildPpuSequence_CheckModeBinary:
  DEX
  BPL HandlePracticeMenu_BuildPpuSequence_CheckModeBool

  ; Write as binary.
  ; 8 digits, with 0 or 1 for each.
  LDX #$07
 -
  LSR
  TAY
  LDA #$00
  BCC +
  LDA #$01
 +
  STA mutable_ppu_sequence+3+22,X
  TYA
  DEX
  BPL -

  RTS


 HandlePracticeMenu_BuildPpuSequence_CheckModeBool:
  DEX
  BPL HandlePracticeMenu_BuildPpuSequence_CheckModeConfirm

  ; Write as a bool.
  CMP #$00
  BEQ +

  ; True.
  LDY #<((dValueBoolYes_End - dValueBoolYes) - 1)
 -
  LDA dValueBoolYes,Y
  STA mutable_ppu_sequence+3+30 - <(dValueBoolYes_End - dValueBoolYes),Y
  DEY
  BPL -
  RTS


 +
  ; False.
  LDY #<((dValueBoolNo_End - dValueBoolNo) - 1)
 -
  LDA dValueBoolNo,Y
  STA mutable_ppu_sequence+3+30 - <(dValueBoolNo_End - dValueBoolNo),Y
  DEY
  BPL -
  RTS


 HandlePracticeMenu_BuildPpuSequence_CheckModeConfirm:
  DEX
  BPL HandlePracticeMenu_BuildPpuSequence_CheckModeMemory

  ; Only write in the value field when editing the value. No need to ask for confirmation when just browsing the menu.
  LDA current_menu_state
  BEQ HandlePracticeMenu_BuildPpuSequence_Done

  ; Confirm?
  LDY #<((dValueConfirm_End - dValueConfirm) - 1)
 -
  LDA dValueConfirm,Y
  STA mutable_ppu_sequence+3+30 - <(dValueConfirm_End - dValueConfirm),Y
  DEY
  BPL -
  RTS


 HandlePracticeMenu_BuildPpuSequence_CheckModeMemory:
  DEX
  BPL HandlePracticeMenu_BuildPpuSequence_CheckModeVersion

  ; Draw as 3 hex bytes.
  LDY #23
  LDA current_address_high
  JSR HandlePracticeMenu_BuildPpuSequence_ModeByte
  LDY #25
  LDA current_address_low
  JSR HandlePracticeMenu_BuildPpuSequence_ModeByte
  LDY #28
  LDA current_byte_cache
  JMP HandlePracticeMenu_BuildPpuSequence_ModeByte


 HandlePracticeMenu_BuildPpuSequence_CheckModeVersion:
  DEX
  BPL HandlePracticeMenu_BuildPpuSequence_Done

  LDA #$01
  STA mutable_ppu_sequence+3+27
  LDA #$2C
  STA mutable_ppu_sequence+3+28
  LDA #$01
  STA mutable_ppu_sequence+3+29
  ; RTS


 HandlePracticeMenu_BuildPpuSequence_Done:
  RTS


; $00-01 = Pointer to menu entry struct.
; $02-03 = Pointer to target value.
; $04-05 = Pointer to menu entry string.
GetMenuPointers:
  LDA #$00
  STA $0F

  ; Get the current entry's text pointer.
  LDA current_menu_entry
  ASL
  TAX
  LDA dMenuEntryPointers,X
  STA $00
  LDA dMenuEntryPointers+1,X
  STA $01

  ; Get a pointer to the target value.
  LDY #$00
  LDA ($00),Y
  TAX
  INY
  LDA ($00),Y
  STX $02
  STA $03

  ; Get a pointer to the string. If this uses byte mode, there's also a limit we need to skip over.
  CLC
  INY
  LDA ($00),Y
  BNE +
  ; Save the limit for later and set carry to adjust the string pointer.
  INY
  LDA ($00),Y
  STA $0F
  SEC
 +
  LDA $00
  ADC #$03
  STA $04
  LDA $01
  ADC #$00
  STA $05  

  RTS


; Returns the page number in Y, one-indexed.
GetCurrentMenuPage:
  LDY #$FF
  LDA current_menu_entry
 -
  INY
  CMP dMenuPages,Y
  BCS -

 GetCurrentMenuPage_Done:
  RTS


CheckMenuEntryValid:
  LDY current_menu_entry

  ; If this is the version display, mark it invalid; we don't want it to be editable.
  CPY #<((dMenuSpecialVersion - dMenuEntryPointers)/2)
  BEQ CheckMenuEntryValid_Invalid

  ; Validate the enemy ID we're forcefully loading.
  CPY #<((dMenuSpecialForceEnemyId - dMenuEntryPointers)/2)
  BEQ CheckMenuEntryValid_CheckEnemy

  ; Validate the screen for the current level.
  CPY #<((dMenuSpecialScreen - dMenuEntryPointers)/2)
  BNE CheckMenuEntryValid_Done

  ; If we're in the right menu state, allow editing the screen entry.
  LDA current_menu_state
  BEQ CheckMenuEntryValid_Done

  ; Always allow negative values, which take us out of the current area.
  LDA current_byte_cache
  BMI CheckMenuEntryValid_Done

 CheckMenuEntryValid_CheckScreenInLevel:
  TAX

  ; If this is second quest, adjust the index to the second quest values.
  LDY current_save_slot
  LDA is_second_quest,Y
  BEQ +
  TXA
  ORA #$80
  TAX
 +

  ; If this is the overworld, allow all screens.
  LDY current_level
  BEQ CheckMenuEntryValid_Done

  ; Get the level flag value into A. Levels 1-8 use bits 0-7 as flags. Level 9 uses #$C0 due to lack of an extra bit,
  ; since levels 7 and 8 are on the same map and can never share screens. Levels 7-9 must match exactly in bits 7 and
  ; 8.
  LDA #$C0
  CPY #$09
  BCS +
  DEY
  LDA dBitTable,Y
 +
  STA $07

  ; While $07 contains the value that we need to match, A contains the mask we use to get the bits we care about. For
  ; dungeons 1-6, that's just the level's flag, but for 7-9, we need to match perfectly in the top two bits.
  CMP #$40
  BCC +
  LDA #$C0
 +
  AND dValidDungeonScreens,X
  CMP $07
  BNE CheckMenuEntryValid_Invalid
  RTS


 CheckMenuEntryValid_CheckEnemy:
  ; If we're in the right menu state, allow editing the ID.
  LDA current_menu_state
  BEQ CheckMenuEntryValid_Done

  ; Only disallow armos enemies.
  LDA current_byte_cache
  CMP #$1E
  BNE CheckMenuEntryValid_Done

 CheckMenuEntryValid_Invalid:
  INC menu_entry_invalid

 CheckMenuEntryValid_Done:
  RTS


HandleMenuInput:
  ; Default to marking that the menu needs to be redrawn. If we reach the end and nothing happened, we can clear this.
  LDA #$01
  STA $06

  ; Choose between handling menu entries or value editing.
  LDA current_menu_state
  BEQ +
  JMP HandleValueEditing

 +
  ; We're selecting menu entries, not editing them.
  LDA joypad1_press
  LSR
  BCC HandleMenuInput_CheckLeft

  ; Right (next page).
  JSR GetCurrentMenuPage

  ; If we went past the last page (page start index is the terminator value), wrap back to the first page.
  LDA dMenuPages,Y
  CMP #$FF
  BNE +
  LDY #$00
 +
  LDA dMenuPages,Y
  STA current_menu_entry

  RTS


 HandleMenuInput_CheckLeft:
  LSR
  BCC HandleMenuInput_CheckDown

  ; Left (previous page).
  JSR GetCurrentMenuPage

  ; If we're on the first page, choose the terminator page before decrementing to wrap to the last page.
  DEY
  BNE +
  LDY #<(dMenuPages_Terminator - dMenuPages)
 +
  DEY
  LDA dMenuPages,Y
  STA current_menu_entry

  RTS


 HandleMenuInput_CheckDown:
  LSR
  BCC HandleMenuInput_CheckUp

  ; Down (next entry).
  JSR GetCurrentMenuPage

  ; Find the first entry past this page.
  LDA dMenuPages,Y
  CMP #$FF
  BNE +
  LDA #((dMenuEntryPointers_End - dMenuEntryPointers)/2)
 +

  ; Increment the entry. If it's gone beyond this page, return to the start of the page.
  INC current_menu_entry
  CMP current_menu_entry
  BNE +
  LDA dMenuPages-1,Y
  STA current_menu_entry
 +

  RTS

 HandleMenuInput_CheckUp:
  LSR
  BCC HandleMenuInput_CheckSelect

  ; Up (previous entry).
  JSR GetCurrentMenuPage

  ; If this isn't the first entry of the page, just decrement it.
  LDA dMenuPages-1,Y
  CMP current_menu_entry
  BEQ +
  DEC current_menu_entry
  RTS

 +
  ; Load the first entry of the next page and then decrement it to wrap to the end of the current page.
  LDX dMenuPages,Y
  CPX #$FF
  BNE +
  LDX #((dMenuEntryPointers_End - dMenuEntryPointers)/2)
 +
  DEX
  STX current_menu_entry
  RTS

 HandleMenuInput_CheckSelect:
  LSR
  LSR
  BCC HandleMenuInput_CheckA

  ; Select (exit menu).
  ; Mark that we're exiting so we can do the delay frame.
  LSR is_menu_active

  ; Clear our the cursor sprite.
  LDA #$F8
  STA $0250

  ; Clear the menu off the HUD.
  LDA #$7E
  STA current_ppu_sequence

  ; We're exiting the menu and want to clear it out, so claim we did nothing so we don't try to redraw the entry.
  BNE HandleMenuInput_NoChange  ; Unconditional.

 HandleMenuInput_CheckA:
  LSR
  LSR
  BCC HandleMenuInput_NoChange

  ; A (edit entry).
  JSR CheckMenuEntryValid
  LDA menu_entry_invalid
  BNE HandleMenuInput_NoChange

  ; Start editing the entry.
  INC current_menu_state

  ; If this is the memory editor, get the current value of the current memory editor address.
  LDA current_menu_entry
  CMP #<((dMenuSpecialEditMemory - dMenuEntryPointers)/2)
  BNE +
  JMP LoadMemoryEditorValue
 +

  ; Get the current value of the address.
  LDY #$00
  LDA ($02),Y
  STA current_byte_cache
  RTS

 HandleMenuInput_NoChange:
  LDA #$00
  STA $06
  RTS


EditEdgeSpawns:
  ; Find the current entry.
  LDY #<(dValidEdgeSpawns_End - dValidEdgeSpawns - 1)
  LDA dValidEdgeSpawns,Y
  LDA current_byte_cache
 -
  CMP dValidEdgeSpawns,Y
  BEQ +
  DEY
  BNE -
 +

  ; Pick the next or previous entry depending on direction.
  LDA joypad1_press
  AND #$01
  BEQ EditEdgeSpawns_CheckPrevious

  ; Next.
  INY
  CPY #<(dValidEdgeSpawns_End - dValidEdgeSpawns)
  BNE +
  LDY #$00
 +
  LDA dValidEdgeSpawns,Y
  STA current_byte_cache
  RTS


 EditEdgeSpawns_CheckPrevious:
  LDA joypad1_press
  AND #$02
  BEQ HandleMenuInput_NoChange

  ; Previous.
  DEY
  CPY #$FF
  BNE +
  LDY #<(dValidEdgeSpawns_End - dValidEdgeSpawns - 1)
 +
  LDA dValidEdgeSpawns,Y
  STA current_byte_cache
  RTS



; Subgrid offset goes #$F9-07, so it won't work with the normal limit system.
ApplyLimitPositive_LinkSubgridOffset:
  STA current_byte_cache

  CMP #$F9
  BCS +

  CMP #$08
  BCC +

  LDA #$F9
  STA current_byte_cache

 +
  RTS


; Beam swords don't work if current health is above max health, so prevent it.
ApplyLimitPositive_Health:
  LDY current_byte_cache
  CPY #$FF
  BEQ +

  CMP current_byte_cache
  BCS +
  LDA #$FF
  BNE ApplyLimitPositive_Health_SetValue  ; Unconditional.

 +
  STA current_byte_cache

  ;LDA current_byte_cache
  AND #$0F
  STA $07

  LDA current_byte_cache
  LSR
  LSR
  LSR
  LSR

  CMP $07
  BCS +
  LDA current_byte_cache
  AND #$F0
 ApplyLimitPositive_Health_SetValue:
  STA current_byte_cache
 +
  RTS


; Takes the amount to add in Y.
ApplyLimitPositive:
  CLC
  ADC current_byte_cache

  ; Handle subgrid offset and health limits using their own special logic.
  LDX current_menu_entry
  CPX #<((dMenuSpecialHealth - dMenuEntryPointers)/2)
  BEQ ApplyLimitPositive_Health
  CPX #<((dMenuSpecialLinkSubgridOffset - dMenuEntryPointers)/2)
  BEQ ApplyLimitPositive_LinkSubgridOffset

  ; If the value is equal to the upper limit, set to 0.
  LDY current_byte_cache
  CPY $0F
  BNE +
  LDA #$00
  BEQ ApplyLimitPositive_Done  ; Unconditional.

 +
  ; If we wrapped around (became less despite adding), set to the limit.
  CMP current_byte_cache
  BCC ApplyLimitPositive_SetToLimit

  ; If we're above the limit, set to the limit.
  CMP $0F
  BCC ApplyLimitPositive_Done

 ApplyLimitPositive_SetToLimit:
  LDA $0F

 ApplyLimitPositive_Done:
  STA current_byte_cache
  RTS


; Subgrid offset goes #$F9-07, so it won't work with the normal limit system.
ApplyLimitNegative_LinkSubgridOffset:
  STA current_byte_cache

  CMP #$08
  BCC +

  CMP #$F9
  BCS +

  LDA #$07
  STA current_byte_cache

 +
  RTS


; Beam swords don't work if current health is above max health, so prevent it.
ApplyLimitNegative_Health:
  LDY current_byte_cache
  BNE +
  LDA #$FF
  BNE ApplyLimitNegative_Health_SetValue  ; Unconditional.

 +
  STA current_byte_cache

  ; Save current health.
  AND #$0F
  STA $07

  ; Get max health.
  LDA current_byte_cache
  LSR
  LSR
  LSR
  LSR

  ; If max health >= current health, we're in-bounds.
  CMP $07
  BCS +

  ; Save max health.
  STA $07

  ; Save whether we got here from pressing left.
  LDA joypad1_press
  AND #$02
  TAY

  ; Set current health to max health.
  LDA current_byte_cache
  AND #$F0
  ORA $07

  ; If we got here by pressing left, then we went from, say, #$80 to #$7F and are now #$77 when we want to be #$88. So,
  ; fix this up by adding 1 to each of max and current health.
  CPY #$02
  BNE ++
  CLC
  ADC #$11
 ++
 ApplyLimitNegative_Health_SetValue:
  STA current_byte_cache

 +
  RTS


ApplyLimitNegative:
  CLC
  ADC current_byte_cache

  ; Handle subgrid offset and health limits using their own special logic.
  LDX current_menu_entry
  CPX #<((dMenuSpecialHealth - dMenuEntryPointers)/2)
  BEQ ApplyLimitNegative_Health
  CPX #<((dMenuSpecialLinkSubgridOffset - dMenuEntryPointers)/2)
  BEQ ApplyLimitNegative_LinkSubgridOffset

  ; If the value is equal to 0, set to the upper limit.
  LDY current_byte_cache
  BNE +
  LDA $0F
  JMP ApplyLimitNegative_Done

 +
  ; If we wrapped around (becomes more despite subtracting), set to 0.
  CMP current_byte_cache
  BCC +
  LDA #$00
 +

 ApplyLimitNegative_Done:
  STA current_byte_cache
  RTS



EditValueModeByte:
  ; Edge spawns are handled in their own way.
  LDA current_menu_entry
  CMP #<((dMenuSpecialEdgeSpawn - dMenuEntryPointers)/2)
  BNE +
  JMP EditEdgeSpawns
 +

  ; Right (+1).
  LDA joypad1_press
  LSR
  BCC +
  LDA #$01
  JMP ApplyLimitPositive

 +
  ; Left (-1).
  LSR
  BCC +
  LDA #$FF
  JMP ApplyLimitNegative


 +
  ; If this byte is only ever 1 digit, don't allow +/-10.
  LDY $0F
  BEQ ++
  CPY #$10
  BCC EditValueModeByte_NoChange
 ++
  LDY current_menu_entry
  CPY #<((dMenuSpecialLinkSubgridOffset - dMenuEntryPointers)/2)
  BEQ EditValueModeByte_NoChange

  ; Down (+10).
  LSR
  BCC +
  LDA #$10
  JMP ApplyLimitPositive

 +
  ; Up (-10).
  LSR
  BCC +
  LDA #$F0
  JMP ApplyLimitNegative

 +
 EditValueModeByte_NoChange:
  ; No change.
  LDA #$00
  STA $06
  RTS



EditValueModeBinary:
  LDA current_menu_entry

  ; Right (right one digit).
  LDA joypad1_press
  LSR
  BCC EditValueModeBinary_CheckLeft

  ; Move right 1 digit.
  LDY current_menu_state
  DEY
  BNE +
  LDY #$08
 +
  STY current_menu_state
  RTS


 EditValueModeBinary_CheckLeft:
  ; Left (left one digit).
  LSR
  BCC EditValueModeBinary_CheckDown

  ; Move left 1 digit.
  LDY current_menu_state
  INY
  CPY #$09
  BNE +
  LDY #$01
 +
  STY current_menu_state
  RTS


 EditValueModeBinary_CheckDown:
  ; Up and down both toggle the value.
  AND #$03
  BEQ EditValueModeBinary_NoChange

  ; Flip the bit value.
  LDY current_menu_state
  DEY
  LDA dBitTable,Y
  EOR current_byte_cache
  STA current_byte_cache

  RTS


 EditValueModeBinary_NoChange:
  ; No change.
  LDA #$00
  STA $06
  RTS



EditValueModeBool:
  ; Left and right toggle the value.
  LDA joypad1_press
  AND #$03
  BEQ EditValueModeBinary_NoChange

  ; Flip between false (zero) and true (non-zero).
  CLC
  LDA current_byte_cache
  BNE +
  SEC
 +
  LDA #$00
  ROL
  STA current_byte_cache
  RTS



EditValueModeMemory_DoPositive:
  ; If this is the top digit of the address, we need to restrict it to valid memory regions.
  LDA current_menu_state
  CMP #$06
  BEQ EditValueModeMemory_DoPositive_TopmostNybble

  ; Otherwise, we can do common handling of ones and of tens.
  SBC #$00  ; Zero-index it.
  LSR
  TAY
  LDA current_byte_cache,Y
  BCS EditValueModeMemory_DoPositive_UpperNybbles

  ; Low nybble.
  TAX
  AND #$F0
  STA $07
  INX
  TXA
  AND #$0F
  ORA $07
  STA current_byte_cache,Y
  RTS


 EditValueModeMemory_DoPositive_UpperNybbles:
  ; C == 1.
  ADC #$0F
  STA current_byte_cache,Y
  RTS


 EditValueModeMemory_DoPositive_TopmostNybble:
  LDA current_byte_cache+2
  CLC
  ADC #$10
  CMP #$80
  BCC +
  ; >= #$80, so set to #$0x.
  AND #$0F
  JMP EditValueModeMemory_DoPositive_WriteTopmost

 +
  CMP #$60
  BCS EditValueModeMemory_DoPositive_WriteTopmost

  CMP #$20
  BCC EditValueModeMemory_DoPositive_WriteTopmost
  ; >= #$20, so set to #$6x.
  AND #$0F
  ORA #$60

 EditValueModeMemory_DoPositive_WriteTopmost:
  STA current_byte_cache+2
  RTS



EditValueModeMemory_DoNegative:
  ; If this is the top digit of the address, we need to restrict it to valid memory regions.
  LDA current_menu_state
  CMP #$06
  BEQ EditValueModeMemory_DoNegative_TopmostNybble

  ; Otherwise, we can do common handling of ones and of tens.
  SBC #$00  ; Zero-index it.
  LSR
  TAY
  LDA current_byte_cache,Y
  BCS EditValueModeMemory_DoNegative_UpperNybbles

  ; Low nybble.
  TAX
  AND #$F0
  STA $07
  DEX
  TXA
  AND #$0F
  ORA $07
  STA current_byte_cache,Y
  RTS


 EditValueModeMemory_DoNegative_UpperNybbles:
  ; C == 1.
  SBC #$10
  STA current_byte_cache,Y
  RTS


 EditValueModeMemory_DoNegative_TopmostNybble:
  LDA current_byte_cache+2
  SEC
  SBC #$10
  CMP #$80
  BCC +
  ; >= #$80, so set to #$7x.
  AND #$0F
  ORA #$70
  JMP EditValueModeMemory_DoNegative_WriteTopmost

 +
  CMP #$60
  BCS EditValueModeMemory_DoNegative_WriteTopmost

  CMP #$20
  BCC EditValueModeMemory_DoNegative_WriteTopmost
  ; >= #$20, so set to #$1x.
  AND #$0F
  ORA #$10

 EditValueModeMemory_DoNegative_WriteTopmost:
  STA current_byte_cache+2
  RTS


; In order to remember its address, the memory editor doesn't use the address in the menu entry.
LoadMemoryEditorValue:
  LDA current_menu_state
  BEQ +
  CMP #$03
  BCC ++
 +
  LDA current_address_low
  STA $08
  LDA current_address_high
  STA $09
  LDY #$00
  LDA ($08),Y
  STA current_byte_cache

 ++
  RTS


EditValueModeMemory:
  ; Right (right one digit).
  LDA joypad1_press
  LSR
  BCC EditValueModeMemory_CheckLeft

  ; Move right 1 digit.
  LDY current_menu_state
  DEY
  BNE +
  LDY #$06
 +
  STY current_menu_state
  RTS


 EditValueModeMemory_CheckLeft:
  ; Left (left one digit).
  LSR
  BCC EditValueModeMemory_CheckDown

  ; Move left 1 digit.
  LDY current_menu_state
  INY
  CPY #$07
  BNE +
  LDY #$01
 +
  STY current_menu_state
  RTS

 EditValueModeMemory_CheckDown:
  ; Down (+10).
  LSR
  BCC EditValueModeMemory_CheckUp

  JSR EditValueModeMemory_DoPositive
  JMP LoadMemoryEditorValue

 EditValueModeMemory_CheckUp:
  ; Up (-10).
  LSR
  BCC EditValueModeMemory_NoChange

  JSR EditValueModeMemory_DoNegative
  JMP LoadMemoryEditorValue

 EditValueModeMemory_NoChange:
  ; No change.
  LDA #$00
  STA $06
 EditValueModeMemory_Return:
  RTS


; Clears out all killed-enemy state.
CommitValueModeConfirm:
  LDA current_menu_entry
  CMP #<((dMenuSpecialClearScreen - dMenuEntryPointers)/2)
  BEQ CommitValueModeConfirm_ClearScreen
  CMP #<((dMenuSpecialReviveEnemies - dMenuEntryPointers)/2)
  BNE EditValueModeMemory_Return

  ; Revive enemies.
  ; Current screen.
  LDA #$00
  STA num_enemies_killed

  ; Dungeon enemies.
  TAY
 -
  STA dungeon_screen_enemy_status,Y
  INY
  BPL -

  ; Overworld.
  TAY
 -
  LDA overworld_screen_status,Y
  AND #$F8
  STA overworld_screen_status,Y
  INY
  BPL -

  ; Dungeon bosses.
  LDY #$00
 -
  LDA dungeon_screen_status_map1,Y
  AND #$3F
  STA dungeon_screen_status_map1,Y
  INY
  BNE -

  ; Recent screens.
  LDY #$05
  LDA #$FF
 -
  STA recent_screens,Y
  DEY
  BPL -

  RTS


 CommitValueModeConfirm_ClearScreen:
  LDY #$0B
 -
  LDA dynamic_id,Y
  CMP #$5D
  BCS +

  LDA #$00
  STA dynamic_id,Y
 +

  DEY
  BNE -

  RTS




CommitValueModeMemory:
  LDA current_address_low
  STA $08
  LDA current_address_high
  STA $09

  LDA current_byte_cache
  LDY #$00
  STA ($08),Y
  RTS


HandleValueEditing:
  ; A (commit).
  BIT joypad1_press
  BPL HandleValueEditing_CheckB

  ; If the value isn't valid, don't commit.
  JSR CheckMenuEntryValid
  LDA menu_entry_invalid
  BNE HandleValueEditing_NoChange

  LDY #$02
  LDA ($00),Y

  ; Stop editing.
  LDY #$00
  STY current_menu_state

  ; Some modes require special handling.
  CMP #kEditModeConfirm
  BNE +
  JMP CommitValueModeConfirm
 +
  CMP #kEditModeMemory
  BNE +
  JMP CommitValueModeMemory
 +

  ; Commit the byte.
  LDA current_byte_cache
  STA ($02),Y

  ; If we updated the level number, we need to set up a level transition later.
  LDA current_menu_entry
  CMP #<((dMenuSpecialLevel - dMenuEntryPointers)/2)
  BNE +

  ; Enter level.
  LDA change_flags
  ORA #$80
  STA change_flags
  RTS

 +
  ; If we updated the screen index, we need to set up a screen transition later.
  CMP #<((dMenuSpecialScreen - dMenuEntryPointers)/2)
  BNE +

  ; Enter screen.
  LDA change_flags
  ORA #$40
  STA change_flags
 +

  RTS

 HandleValueEditing_CheckB:
  ; B (cancel).
  BVC +

  ; Cancel. Stop editing and return to the standard menu.
  LDY #$00
  STY current_menu_state
  RTS

 +
  ; Enter the edit handler for this mode.
  LDY #$02
  LDA ($00),Y

  TAY
  BNE +
  JMP EditValueModeByte

 +
  DEY
  BNE +
  JMP EditValueModeBinary

 +
  DEY
  BNE +
  JMP EditValueModeBool

 +
  DEY
  BEQ HandleValueEditing_NoChange  ; Commit mode.

  DEY
  BNE +
  JMP EditValueModeMemory

 +
 HandleValueEditing_NoChange:
  ; No change.
  LDA #$00
  STA $06
  RTS


dScrollingOffsetTable:
  .db $10,$F0,$01,$FF

dLevelExitScreens:
  .db $77,$37,$3C,$74,$45,$0B,$22,$42,$6D,$05
  .db $77,$37,$3C,$34,$45,$1B,$30,$19,$6C,$00

dLevelExitTiles:
  .db $70,$24,$24,$24,$24,$70,$24,$70,$70,$24
  .db $70,$24,$70,$70,$24,$70,$70,$24,$70,$24


ForceUnpause:
  LDA #$00
  STA pause_status
  STA is_menu_active
  LDA #$0F
  STA SOUND_CONTROL
  RTS


HandleChangeFlags:
  LDA change_flags
  ASL
  BCC HandleChangeFlags_CheckScreen

  ; Enter level.

  ; If the screen was also changed, set an override for the level's entry screen.
  ASL
  BCC +

  ; If the screen is negative, don't use it.
  LDA current_screen
  BMI +

  ; If the screen isn't in the level, don't use it.
  JSR CheckMenuEntryValid_CheckScreenInLevel
  LDA menu_entry_invalid
  BNE +

  ; Set the entry screen and mark the top bit so we know to use the value.
  LDA current_screen
  ORA #$80
  STA force_entry_screen
 +

  JSR ForceUnpause

  ; Start a level transition.
  LDA #$02
  STA current_mode
  LDA #$00
  STA current_task
  STA current_state

  STA entrance_type_unknown

  LDA #$70
  STA link_collision_tile

  ; Set up the exit properly to match the real level entrance.
  LDX #$00
  LDY current_save_slot
  LDA is_second_quest,Y
  BEQ +
  LDX #$0A
 +
  TXA
  CLC
  ADC current_level
  TAY
  LDA dLevelExitScreens,Y
  STA cave_exit_screen
  LDA dLevelExitTiles,Y
  STA entrance_tile

  ; Stop music and sound effects.
  JSR $6EE9
  JMP HandleChangeFlags_Done


 HandleChangeFlags_CheckScreen:
  ASL
  BCC HandleChangeFlags_Done

  ; Enter screen.
  ; If we're in a special screen and already fixed up the palettes, finish the special work required.
  LDA change_flags
  AND #$01
  BNE HandleChangeFlags_TransitionScreenFromSpecial

  ; If this is a cave or passageway, we need to do additional setup.
  LDA current_mode
  CMP #$05
  BEQ HandleChangeFlags_TransitionScreen

  ; We're in a cave or passageway. Set a special flag for doing more work next frame.
  LDA change_flags
  ORA #$01
  STA change_flags

  ; Add the ring color to the area metadata.
  LDX <current_save_slot
  LDY $EA0E,X
  LDA $6804,Y
  STA $6B92

  ; Request that palettes be fixed up and another delay frame on which to do this work.
  LDA #$18
  STA current_ppu_sequence 
  LDA #$40
  STA is_menu_active

  ; Finish handling this on the next frame.
  RTS

 HandleChangeFlags_TransitionScreenFromSpecial:
  ; If this is the overworld, the cave will have disabled music, so reenable it.
  LDA current_level
  BNE +
  LDA #$01
  STA $0600
 +

 HandleChangeFlags_TransitionScreen:
  ; Prevent funky scrolling.
  LDA #$00
  STA entrance_type_unknown

  ; Indicate that we shouldn't save enemies when warping.
  LDA #$FF
  STA skip_saving_kills

  ; Align Link to a grid intersection so scrolling works more correctly.
  LDA link_pos_x
  AND #$F8
  STA link_pos_x

  LDA link_pos_y
  CLC
  ADC #$03
  AND #$F8
  SEC
  SBC #$03
  STA link_pos_y

  LDA #$00
  STA link_subgrid_offset

  JSR ForceUnpause

  ; Start the screen transition.
  LDA #$06
  STA current_mode
  LDA #$00
  STA current_task
  STA current_state

  ; Offset the index based on the direction Link is facing to get the screen Link is scrolling from.
  LDA link_face_direction
  JSR GetOppositeDirection

  LDA dScrollingOffsetTable,Y
  CLC
  ADC current_screen
  STA current_screen

 HandleChangeFlags_Done:
  LDA #$00
  STA change_flags
  RTS


dMenuCursorXPositions:
  .db $08,$E8,$E0

dMenuBinaryCursorXPositions:
  .db $E8,$E0,$D8,$D0,$C8,$C0,$B8,$B0

dMenuMemoryCursorXPositions:
  .db $E8,$E0,$D0,$C8,$C0,$B8


DrawMenuArrow_Byte:
  ; Byte.
  ; The X position depends on whether we're drawing 1 or 2 digits.
  LDA $0F
  BEQ ++
  CMP #$10
  BCS ++
  LDA #$E0
  BNE DrawMenuArrow_Common  ; Unconditional.

 ++
  LDA #$D8
  BNE DrawMenuArrow_Common  ; Unconditional.


DrawMenuArrow_Binary:
  LDY current_menu_state
  LDA dMenuBinaryCursorXPositions-1,Y
 DrawMenuArrow_DrawOverline:
  STA $0253  ; X.

  LDA #$27
  STA $0250  ; Y

  LDA frame_counter
  LSR
  LSR
  LSR
  AND #$03
  TAY
  LDA #$30
  BNE DrawMenuArrow_SetTile  ; Unconditional.


DrawMenuArrow_Bool:
  LDA current_byte_cache
  BEQ ++
  ; Yes.
  LDA #$D0
  BNE DrawMenuArrow_Common  ; Unconditional.
 ++
  ; No.
  LDA #$D8
  BNE DrawMenuArrow_Common  ; Unconditional.


DrawMenuArrow_Confirm:
  LDA #$A8
  BNE DrawMenuArrow_Common  ; Unconditional.


DrawMenuArrow_Memory:
  LDY current_menu_state
  LDA dMenuMemoryCursorXPositions-1,Y
  JMP DrawMenuArrow_DrawOverline
  


DrawMenuArrow:
  LDY current_menu_state
  BEQ DrawMenuArrow_MenuEntry

  LDY #$02
  LDA ($00),Y
  TAX
  BEQ DrawMenuArrow_Byte
  DEX
  BEQ DrawMenuArrow_Binary
  DEX
  BEQ DrawMenuArrow_Bool
  DEX
  BEQ DrawMenuArrow_Confirm
  DEX
  BEQ DrawMenuArrow_Memory


 DrawMenuArrow_MenuEntry:
  LDA #$08

 DrawMenuArrow_Common:
  STA $0253  ; X.

  LDA #$2F
  STA $0250  ; Y.

  LDA frame_counter
  LSR
  LSR
  LSR
  AND #$03
  TAY
  LDA #$40
 DrawMenuArrow_SetTile:
  ORA dMenuArrowRowOffsets,Y
  STA $0251  ; Tile ID.

  LDA #$02
  LDY menu_entry_invalid
  BEQ +
  LDA #$01
 +
  STA $0252  ; Flags.

  RTS


  .IF $ > $BF50
  .ERROR Exceeded free region.
  .ENDIF



.PATCH 04:AC94

  JSR GanonLightRoom



.PATCH 04:AD0A

  JMP PatchObjectAiGanon
 PatchObjectAiGanon_Return:



.PATCH 04:B500

PatchObjectAiGanon:
  LDA show_ganon
  BEQ +
  JSR $AEB5
 +
  INC $046B,X
  JMP PatchObjectAiGanon_Return


GanonLightRoom:
  LDA room_light_mode
  JSR UseJumpTable
  .dw $B1D1  ; Updates this to skip the 'Is room dark?' check.
  .dw $B1E4
  .dw $B1DC



  .IF $ > $BF50
  .ERROR Exceeded free region.
  .ENDIF



.PATCH 05:82CD

  ; Skips most of the HandleDoorScrollType function, which is a vestigial function that misbehaves in dungeons when
  ; scrolling and not in a door.
  JSR $E6B8



.PATCH 05:81E1
  LDY scroll_type
.PATCH 05:8259
  LDY scroll_type
.PATCH 05:8429
  ; Patch the tick frame mode handler for setting up fast scrolling.
  .dw PatchModeScrollStateInit
.PATCH 05:8459
  LDX scroll_type
.PATCH 05:8466
  LDX scroll_type
.PATCH 05:849B
  LDY scroll_type



.PATCH 05:88C7

  JSR PatchEnemyLoading
  NOP
  NOP



.PATCH 05:B08A

  JSR PatchSaveKilledEnemies



.PATCH 05:B900

PatchInitMode05:
  LDA #$00
  STA secs
  STA frames
  JMP $EA6B

PatchInitMode09:
  LDA #$00
  STA secs
  STA frames
  JMP InitMode09

PatchInitMode0A:
  LDA #$00
  STA secs
  STA frames
  JMP $B0FC

PatchInitMode0B:
  LDA #$00
  STA secs
  STA frames
  JMP InitMode0B

PatchInitMode0C:
  LDA #$00
  STA secs
  STA frames
  JMP InitMode0C


ClearLowerStackRegion:
  LDY #$2F
  LDA #$00
 -
  STA $0100,Y
  DEY
  BPL -

  ; A must be #$00 when entering Setup.
  JMP Setup



PatchModeScrollStateInit:
  LDA #$00
  LDY scroll_fast
  BNE +
  LDA current_level
 +
  STA scroll_type

  JMP $8439  ; ModeScrollStateInit



PatchEnemyLoading:
  ; If we're not forcing enemies, exit.
  LDA force_enemies
  BEQ PatchEnemyLoading_Done

  ; If this is a passageway, don't force enemies.
  LDA current_mode
  CMP #$09
  BEQ PatchEnemyLoading_Done

  ; If this screen doesn't have enemies, don't force enemies onto it.
  LDY current_screen
  LDA current_area_table_2,Y
  AND #$1F
  BNE +
  LDA current_area_table_3,Y
  BPL PatchEnemyLoading_Done
 +

  ; If we're forcing 0 enemies, exit.
  LDA force_enemy_quantity
  STA $03
  BEQ PatchEnemyLoading_Done

  ; Set the enemy or group ID we're forcing.
  LDA force_enemy_id
  STA $02

  ; Bosses and special objects are limited to 1 per screen.
  CMP #$32
  BCC +
  CMP #$62
  BCS +
  LDA #$01
  STA $03
 +

 PatchEnemyLoading_Done:
  LDA $03
  STA num_enemies_loaded

  RTS



PatchSaveKilledEnemies:
  ; If we're warping, we don't want to save kills.
  LDA skip_saving_kills
  BNE +
  JMP $B464

 +
  LDA #$00
  STA skip_saving_kills
  RTS



  .IF $ > $BF50
  .ERROR Exceeded free region.
  .ENDIF



.PATCH 06:A07E

  .dw PpuSequenceClearHudMenu



.IF !dVersionIsPrg1
.PATCH 06:A2D6
.ELSE
.PATCH 06:A361
.ENDIF

  .db $00,$00,$00,$00,$00,$00



.PATCH 06:B0F8

PpuSequenceClearHudMenu:
  .db $20,$E0
  .db $60
  .db $24
  .db $FF


 DrawPracticeHud_NongameplayMode:
  ; Normally, we don't update on non-gameplay frames. However, because state changes during the last gameplay frame, we
  ; need to update one more time after transitioning to another mode. 
  LDY force_update
  BEQ +
  TXA
  JMP DrawPracticeHud_DoUpdate
 +

  ; Clear the address so we execute from the top left of the nametables.
  STX PPU_ADDRESS
  STX PPU_ADDRESS
  JMP DrawPracticeHud_Return

DrawPracticeHud:
  ; We assume X == 0.

  ; Only update on gameplay frames.
  LDA current_mode
  CMP #$05
  BEQ +
  CMP #$09
  BCC DrawPracticeHud_NongameplayMode
  CMP #$0D
  BCS DrawPracticeHud_NongameplayMode
 +

  LDA current_task
  BEQ DrawPracticeHud_NongameplayMode

 DrawPracticeHud_DoUpdate:
  ; Mark that we need to force an update on the next frame in case it's not a gameplay frame.
  STA force_update

  ; Ensure we update horizontally, not vertically.
  LDA ppu_control_value
  AND #(~$04)
  STA PPU_CONTROL

  ; Set the address of the start of the practice HUD display.
  LDA #$20
  STA PPU_ADDRESS
  LDA #$42
  STA PPU_ADDRESS

  ; Draw the time.
  LDY secs
  LDA dTensTable,Y
  STA PPU_DATA

  LDA dOnesTable,Y
  STA PPU_DATA

  LDA #$2D  ; "
  STA PPU_DATA
  
  LDY frames
  LDA dTensTable,Y
  STA PPU_DATA

  LDA dOnesTable,Y
  STA PPU_DATA


  LDY #$24
  STY PPU_DATA


  ; Draw clip help. Indicate if Link can clip with buffer-only or both buffer and dpad. If not, draw a blank tile.
  LDA link_speed
  CMP #$60
  BNE DrawPracticeHud_SkipClipHelp_Burn31  ; 9
 ClipHelpPreBranch:

  ; 8
  LDA link_face_direction
  AND #$0A  ; up/left
  BEQ DrawPracticeHud_ClipHelpPositive ; 16

  ; Negative. 15
  ; Check buffer-only position.
  LDA link_subgrid_offset
  CMP #$FF
  BNE +
  LDA link_subpos
  BMI DrawPracticeHud_SkipClipHelp_Burn10  ; >= #$80. 30

  ; 29
  LDA #$3C  ; Sword.
  STA PPU_DATA
  NOP
  NOP
  NOP
  BNE DrawPracticeHud_ClipHelpDone  ; Unconditional. 38+6

 +
  ; 24
  ; Check buffer/dpad position.
  CMP #$FD
  BNE DrawPracticeHud_SkipClipHelp_Burn11  ; 29
  LDA link_subpos
  BMI +
  BPL DrawPracticeHud_SkipClipHelp_Burn3  ; < #$80. 37
 +
  ; 35
  LDA #$3D  ; Checkmark.
  STA PPU_DATA
  BNE DrawPracticeHud_ClipHelpDone  ; Unconditional. 44

 DrawPracticeHud_ClipHelpPositive:
  ; Positive. 16
  ; Check buffer-only position.
  LDA link_subgrid_offset
  CMP #$01
  BNE +  ; 25
  ; 24
  LDA link_subpos
  BPL DrawPracticeHud_SkipClipHelp_Burn9  ; < #$80. 31

  ; 30
  BIT $00
  NOP
  LDA #$3C  ; Sword.
  STA PPU_DATA
  BNE DrawPracticeHud_ClipHelpDone  ; Unconditional. 39+5

 +
  ; Check buffer/dpad position. 25
  CMP #$03
  BNE DrawPracticeHud_SkipClipHelp_Burn10  ; 30
  LDA link_subpos
  BMI DrawPracticeHud_SkipClipHelp_Burn4  ; >= #$80. 36

  ; 35
  LDA #$3D  ; Checkmark.
  STA PPU_DATA
  BNE DrawPracticeHud_ClipHelpDone  ; Unconditional. 44


 DrawPracticeHud_SkipClipHelp_Burn31:
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
 DrawPracticeHud_SkipClipHelp_Burn11:
  NOP
 DrawPracticeHud_SkipClipHelp_Burn9:
  NOP
  NOP
 DrawPracticeHud_SkipClipHelp_Burn5:
  NOP
 DrawPracticeHud_SkipClipHelp_Burn3:
  STY PPU_DATA
  JMP DrawPracticeHud_ClipHelpDone


 DrawPracticeHud_SkipClipHelp_Burn10:
  NOP
  NOP
  NOP
 DrawPracticeHud_SkipClipHelp_Burn4:
  NOP
  NOP
  STY PPU_DATA

 DrawPracticeHud_ClipHelpDone:
  ; 44 cycles.

  .IF >ClipHelpPreBranch != >DrawPracticeHud_ClipHelpDone
  .ERROR Clip help branches cross a page boundary.
  .ENDIF


  ; Draw Link's grid position information.
  LDA link_subgrid_offset
  LSR
  LSR
  LSR
  LSR
  STA PPU_DATA

  LDA link_subgrid_offset
  AND #$0F
  STA PPU_DATA

  LDA #$2C  ; .
  STA PPU_DATA
  
  LDA link_subpos
  LSR
  LSR
  LSR
  LSR
  STA PPU_DATA

  STY PPU_DATA


  ; Draw the recorder counter. Modify the value to show which dungeon it will take Link to.
  LDX #$35  ; Whirlwind icon.
  STX PPU_DATA
  LDA recorder_destination_counter
  AND #$07
  CLC
  ADC #$01
  STA PPU_DATA

  STY PPU_DATA


  ; Draw the global counter.
  LDX #$31  ; Global icon.
  STX PPU_DATA

  LDA kill_counter
  AND #$0F
  STA PPU_DATA


  ; Draw the streak counter.
  INX  ; LDX #$32  ; Rupee icon.
  LDA drop_forced_bomb
  BNE +
 ForcedBombPreBranch:
  .db $24  ; BIT Zero Page.
 ForcedBombPostBranch:
 +
  INX  ; LDX #$33  ; Bomb icon.
  STX PPU_DATA
  ; 14

  .IF >ForcedBombPreBranch != >ForcedBombPostBranch
  .ERROR Forced bomb branch crosses a page boundary.
  .ENDIF


  LDA ten_count
  AND #$0F
  STA PPU_DATA


  ; Draw the fairy counter.
  LDX #$34  ; Fairy icon.
  STX PPU_DATA

  LDA fairy_counter
  LSR
  LSR
  LSR
  LSR
  STA PPU_DATA

  LDA fairy_counter
  AND #$0F
  STA PPU_DATA

  STY PPU_DATA


  ; Draw the spawn counter.
  LDX #$4C  ; Cloud spawn icon.
  STX PPU_DATA

  LDA spawn_counter
  AND #$0F
  STA PPU_DATA


  ; Draw the edge spawn position.
  INX  ; LDX #$4D  ; Enemy icon.
  STX PPU_DATA

  LDA edge_spawn_position
  LSR
  LSR
  LSR
  LSR
  STA PPU_DATA

  LDA edge_spawn_position
  AND #$0F
  STA PPU_DATA


  ; Draw the bubble countdown timer. Put this on the bottom edge of the A button box.
  LDX #$00

  LDA #$20
  STA PPU_ADDRESS
  LDA #$D3
  STA PPU_ADDRESS

  LDY sword_disable_timer,X  ; Index with X to burn 1 cycle.
  BEQ +
 BubblePreBranch:
  DEY  ; Adjust it downward so it goes 0-F (fits in one digit).
  JMP ++
  ; Add in padding so we can get meet the timer update branch requirement while aligning earlier branches to not cross
  ; page boundaries.
  .dsb $6F, $00
 BubblePostBranch:
 +
  NOP
  LDY #$6A  ; Bottom box edge.
 ++
  STY PPU_DATA
  ; 15

  .IF >BubblePreBranch != >BubblePostBranch
  .ERROR Bubble timer branch crosses a page boundary.
  .ENDIF


  ; Clear the address so we execute from the top left of the nametables.
  STX PPU_ADDRESS
  STX PPU_ADDRESS


  ; Update the frames/seconds variables. We do this here so it doesn't eat into vblank time.
  ; X == 0.
  LDA frames
  CLC
  ADC #$01
  CMP #60
  BCC dTimerNewPage  ; Force the branch to cross a page boundary so both paths take 4 cycles.
 dTimerOldPage:
  TXA
 dTimerNewPage:
  STA frames

  LDA secs
  ADC #$00
  CMP #100
  BCC +
  TXA
 +
  BCC +  ; Balance the cycles. The first branch area consumes 3 or 4 cycles, so this consumes 3 or 2 to even it out.
 +
  STA secs
  ; 36 cycles

  .IF >dTimerNewPage == >dTimerOldPage
  .ERROR Branch cycle-manipulation failed because branch does not cross a page boundary.
  .ENDIF


  JMP DrawPracticeHud_Return


; Page-align the tables so indexed loads are always 4 cycles.
.dsb $100 - <$, $00

dOnesTable:
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 0
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 10
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 20
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 30
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 40
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 50
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 60
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 70
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 80
    db $0,$1,$2,$3,$4,$5,$6,$7,$8,$9  ; 90

dTensTable:
    db $0,$0,$0,$0,$0,$0,$0,$0,$0,$0  ; 0
    db $1,$1,$1,$1,$1,$1,$1,$1,$1,$1  ; 10
    db $2,$2,$2,$2,$2,$2,$2,$2,$2,$2  ; 20
    db $3,$3,$3,$3,$3,$3,$3,$3,$3,$3  ; 30
    db $4,$4,$4,$4,$4,$4,$4,$4,$4,$4  ; 40
    db $5,$5,$5,$5,$5,$5,$5,$5,$5,$5  ; 50
    db $6,$6,$6,$6,$6,$6,$6,$6,$6,$6  ; 60
    db $7,$7,$7,$7,$7,$7,$7,$7,$7,$7  ; 70
    db $8,$8,$8,$8,$8,$8,$8,$8,$8,$8  ; 80
    db $9,$9,$9,$9,$9,$9,$9,$9,$9,$9  ; 90


  .IF $ > $BF50
  .ERROR Exceeded free region.
  .ENDIF



.PATCH 07:E440  ; CODE

  ; ====[NmiCounter]====
  Setup:
    ; Expects A == #$00.
    STA has_init_sram

    JSR $B4AC  ; ValidateOrInitializeSram
    JSR $B4E8  ; InitializeRam
    JSR $E45E  ; SetUpAudioAndGraphics

    LDA ppu_control_value
    ORA #$A0  ; kPpuControlEnableVblankNmi | kPpuControl8x16Sprites
    STA PPU_CONTROL
    STA ppu_control_value

    ; Set the NMI counter so the next NMI's increment will clear it.
    LDY #$FF
   -
    STY nmi_counter
    JMP -  ; Wait for NMI.


  .IF $ > $E45E
  .ERROR Setup patch too large.
  .ENDIF
  .IF $ < $E45E
    ; Freed space.
    .dsb $E45E - $, $00  ; BRK.
  .ENDIF



.PATCH 07:E484  ; CODE

    ; This just exists here to make debuggers disassemble the start of this function properly.
    BRK

  ; Changes the frame handler to keep NMIs enabled.
  HandleFrame:
    ; Switch the current vertical nametable, if needed.
    LDX <switch_base_nametable
    BEQ +
    EOR #$02  ; kPpuControlScrollYHigh
    STA <ppu_control_value
   +

    AND #$FE  ; ~kPpuControlScrollXHigh
    LDX PPU_STATUS


  .IF $ != $E492
  .ERROR NmiCounter change is wrong length.
  .ENDIF



.PATCH 07:E4C9

  LDX #$00
  STX PPU_ADDRESS
  JMP DrawPracticeHud
  NOP
  NOP
  NOP
 DrawPracticeHud_Return:



.PATCH 07:E53B

  ; Various optimizations to save time.
    JSR $E62D  ; ReadJoypads

    ; Handle the LFSR.
    ; We use zero page wraparound so we can count up toward 0, avoiding the need for a second counter.
    LDX #$F3  ; #$00 - random array size.

    ; If bits 0 and 8 of the LFSR are the same, use 0 as the new random bit. Otherwise, use 1.
    LDA <random_lfsr
    EOR <random_lfsr+1
    LSR
    LSR

    BCS +  ; Burn a cycle if the bit was 1 to match the original behavior.
   +

    ; Advance the random number sequence by 1 bit.
   -
    ROR <random_lfsr+13,X
    INX
    BNE -
    ; X == 0.

    ; Handle all game sounds.
    TXA  ; LDA #$00

    JSR SwitchBank
    JSR $9825  ; HandleAudio

    ; Advance the frame counter.
    INC <frame_counter

    ; If the current mode has already been initialized, handle it. Otherwise, initialize it.
    LDA <current_task
    BNE +
    JSR $E8F8
    JMP ++
   +
    JSR $EB30
   ++

    ; Reenable the NMI for vblank start and clear the bit indicating vblank has started so that the interrupt won't
    ; immediately fire from stale state. We don't do this during scrolling because there shouldn't be any need and we
    ; want to avoid the scanline glitch caused by writing to PPU_CONTROL.
    LDA is_scrolling
    BNE +
    LDA <ppu_control_value
    ORA #$80
    STA <ppu_control_value
    LDX PPU_STATUS
    STA PPU_CONTROL
   +

    ; If the performance monitor is enabled, draw it.
    LDY show_lag
    BEQ +
    JMP ShowLag
   +

    ; We need to set Y back to the value needed to initialize nmi_counter.
    DEY

    ; End the frame.
    RTI

  .IF $ > $E580
  .ERROR HandleFrame too long.
  .ENDIF



.PATCH 07:E92D

  .dw PatchInitMode05



.PATCH 07:E935

  .dw PatchInitMode09
  .dw PatchInitMode0A
  .dw PatchInitMode0B
  .dw PatchInitMode0C



.PATCH 07:EA1F

  JSR PatchFuncBank7_EA11
  STA current_screen

  .IF $ != $EA24
  .ERROR FuncBank7_EA11 patch incorrect length.
  .ENDIF



.PATCH 07:EB44

  .dw HandleModeGameplayTask1

.PATCH 07:EB4C

  .dw HandleModeGameplayTask1
  .dw HandleModeGameplayTask1
  .dw HandleModeGameplayTask1
  .dw HandleModeGameplayTask1



.PATCH 07:EC1C

PatchFuncBank7_EA11:
  ; If we're doing a level and entry screen warp, load the screen and clear the force flag.
  LDX force_entry_screen
  BPL +
  TXA
  AND #$7F
  STA force_entry_screen
 +

  CMP cave_exit_screen
  RTS


 HandleFrame_DoHaltedObjects:
  LDA #$04
  JSR SwitchBank
  JMP $B1BE

 HandleFrame_FinishHandlePause:
  LDA #$05
  JSR SwitchBank
  JSR $B559
  JMP $ED89

 HandleFrame_ContinueBank7:
  ; Inlines HideDynamicSprites to save 12 cycles.

  ; Optimizes loop to saves 80 cycles.
  LDX #$60
  LDA #$F8
 -
  STA $0200,X
  INX
  INX
  INX
  INX
  BNE -

  ; Inlines to save 14 cycles (12 on call and 2 on using X to remove CLC for adding).
  LDX $0342
  INX
  CPX #$28
  BNE +
  LDX #$00
 +
  STX current_sprite_number
  STX $0342

  .IF $ != $EC5B
  .ERROR HandleFrame patch starting at the wrong location.
  .ENDIF




.PATCH 07:ED86

  JSR ShowTarget



.PATCH 07:FF43

ShowLag:
  LDA ppu_mask_value
  ORA #$E0  ; kPpuMaskEmphasizeBlue | kPpuMaskEmphasizeGreen | kPpuMaskEmphasizeRed
  STA PPU_MASK

  LDY #$FF
  RTI




.PATCH 07:FF90

  ; Switch to the correct bank to save some bytes. This used to swap in bank 7 for no reason.
  LDA #$05
  JSR SwitchBank
  JMP ClearLowerStackRegion



.PATCH 07:FFC0

NmiWrapper:
  ; If this isn't a lag frame, handle it as normal.
  INC nmi_counter
  BNE +

  LDA ppu_control_value
  JMP HandleFrame

 +
  ; This is a lag frame. We use force_update as a proxy for what mode we're in, because the mode can change early in
  ; the last gameplay frame before lag might happen. Checking the mode directly would make us miss counting the lag
  ; frame.
  PHA

  LDA force_update
  BEQ NmiWrapper_Done

  ; Count this lag frame.
  LDA frames
  CLC
  ADC #$01
  CMP #60
  BCC +
  LDA #$00
 +
  STA frames
  LDA secs
  ADC #$00
  CMP #100
  BCC +
  LDA #$00
 +
  STA secs

 NmiWrapper_Done:
  PLA
  RTI


  .IF $ > $FFF9 || $ < $FFC0
  .ERROR NmiWrapper overflowed.
  .ENDIF



.PATCH 07:FFFA

  .dw NmiWrapper